//+------------------------------------------------------------------+
//|                                                   		  TreeView |
//|                             Copyright 2006-2011, www.FXmaster.de |
//|                                                  www.FXmaster.de |
//+------------------------------------------------------------------+
#property copyright "Copyright 2006-2011, www.FXmaster.de"
#property link      "www.FXmaster.de"
#property version   "1.00"

#include "View.mqh"
#include "ScrollView.mqh"

#include "..\Tree.mqh"

#import "shell32.dll"
   int ShellExecuteW(int hwnd, string &lpOperation, string &lpFile, string &lpParameters, string &lpDirectory, int nShowCmd);
#import

#define SW_SHOWNORMAL           1
#define SW_SHOWMINIMIZED        2

#define ERROR_BAD_FORMAT        11
#define ERROR_FILE_NOT_FOUND    2 
#define ERROR_PATH_NOT_FOUND    3

#define BTN_CLEAR			0
#define BTN_COLLAPS		1
#define BTN_RESET			2
#define BTN_EXPAND		3
#define BTN_OPEN			4
#define BTN_SHOW			5
#define BTN_LABEL			6
#define BTN_CHECK			7
#define BTN_SCROLL		8
#define BTN_DESCRIPT	9

//------------------------------------------------------------------	class CTreeView
class CTreeView: public CView
{
//---  
public:
	CTreeView(); // 
	~CTreeView(); // 
	void Attach(CTreeCtrl *atree); //      
	void Create(long chart, string name, int wnd, color clr, color bgclr, color selclr, int x, int y, int dx, int dy, int corn=0, int fontsize=8, string font="Arial");
	
//---   
public:
	CTreeCtrl	*m_tree; //      
	int m_sid; //    ( )
	int OnClick(string name); //     
	
//---  
public:
	int m_ndx, m_ndy; //      
	int m_bdx, m_bdy; //   
	CScrollView m_scroll;
	bool m_bProperty; //   -  
	bool m_bDesc; //     
	
	void Draw(); //  
	void DrawTree(CNode *first, int xpos, int &ypos, int &up, int &dn); // 
	void DeleteView(CNode *root=NULL, bool delparent=true); //    ,    
};
//------------------------------------------------------------------	CTreeView
void CTreeView::CTreeView()
{
	m_bdx=12; m_bdy=12; //   
	m_ndx=m_bdx+17; m_ndy=14; //    
	m_sid=0; m_bProperty=false; m_bDesc=false;
}
//------------------------------------------------------------------	~CTreeView
void CTreeView::~CTreeView() 
{
	ObjectDelete(m_chart, m_name);
	ObjectDelete(m_chart, m_name+".collaps");
	ObjectDelete(m_chart, m_name+".expand");
	ObjectDelete(m_chart, m_name+".clear");
	ObjectDelete(m_chart, m_name+".reset");
	ObjectDelete(m_chart, m_name+".open");
	ObjectDelete(m_chart, m_name+".desc");
	ObjectDelete(m_chart, m_name+".prop");
	DeleteView(m_tree.m_root);
 	m_scroll.DeleteView();
 }
//------------------------------------------------------------------	Create
void CTreeView::Create(long achart, string name, int wnd, color clr, color bgclr, color selclr, int x, int y, int dx, int dy, int corn=0, int fontsize=8, string font="Arial")
{
	CView::Create(achart, name,  wnd, clr, bgclr, selclr, x, y, dx, dy, corn, fontsize, font);
	
	x=m_x+m_dx-20; dx=16; 
	y=m_y+2*m_bdy; dy=m_dy-3*m_bdy;
	m_scroll.Create(m_chart, m_name+".scroll", m_wnd, m_selclr, m_bgclr, m_bgclr, x, y, dx, dy, m_corn, m_fontsize);
	m_scroll.m_dir=SV_VDIR;
	OnClick(m_name+string(m_sid)+".lbl");
}
//------------------------------------------------------------------	OnClick
int CTreeView::OnClick(string name) //     
{
	int start=StringLen(m_name); int len=StringFind(name, ".")-start;
	int id=(int)StringToInteger(StringSubstr(name, start, len));
	if (StringFind(name, m_sID+".clear")>=0 && !m_bProperty) 
	{
		DeleteView(); m_tree.Clear(); Draw();
		ObjectSetInteger(m_chart, name, OBJPROP_STATE, false);
		return(BTN_CLEAR);
	}
	else if (StringFind(name, m_sID+".reset")>=0) 
	{
		m_tree.Reset(); Draw();
		ObjectSetInteger(m_chart, name, OBJPROP_STATE, false);
		return(BTN_RESET);
	}
	else if (StringFind(name, m_sID+".collaps")>=0) 
	{
		DeleteView(); m_tree.ExpandBy(TG_ALL, NULL, false); Draw();
		ObjectSetInteger(m_chart, name, OBJPROP_STATE, false);
		return(BTN_COLLAPS);
	}
	else if (StringFind(name, m_sID+".expand")>=0) 
	{
		m_tree.ExpandBy(TG_ALL, NULL, true); Draw();
		ObjectSetInteger(m_chart, name, OBJPROP_STATE, false);
		return(BTN_EXPAND);
	}
	else if (StringFind(name, m_sID+".open")>=0) 
	{
		ObjectSetInteger(m_chart, name, OBJPROP_STATE, false);
		string path=m_tree.m_root.m_path;
		string cmd="open"; string nil="";
		int hWnd=(int)ChartGetInteger(m_chart, CHART_WINDOW_HANDLE);
		int rez=ShellExecuteW(hWnd, cmd, path, nil, nil, SW_SHOWNORMAL);
		if (rez==0) MessageBox("    \n"+path);
		else if (rez==ERROR_BAD_FORMAT) MessageBox(" \'exe\'  ");
		else if (rez==ERROR_FILE_NOT_FOUND) MessageBox("   \n"+path);
		else if (rez==ERROR_PATH_NOT_FOUND) MessageBox("   \n"+path);
		else if (rez<=31) MessageBox("  \n"+path);
		return(BTN_OPEN);
	}
	else if (StringFind(name, m_sID+".desc")>=0) 
	{
		m_bDesc=!m_bDesc;
		if (m_bProperty) m_bDesc=false; //    ,    
		return(BTN_DESCRIPT);
	}
	else if (StringFind(name, ".btn")>=0) //  
	{
		m_tree.ExpandIt(id, !m_tree.IsExpand(id)); //  
		CNode *node=m_tree.FindNode(id); if (NIL(node)) return(0); //    
		DeleteView(node); //      
		Draw(); //  
		return(BTN_SHOW);
	}
	else if (StringFind(name, ".lbl")>=0 && !m_bProperty) //     
	{
		m_tree.SelectBy(TG_ALL, NULL, false);//      
		m_tree.CheckBy(TG_ALL, NULL, false);
		if (m_sid>=0) //   
		{
			ObjectSetInteger(m_chart, m_name+string(m_sid)+".lbl", OBJPROP_COLOR, m_clr);
			ObjectSetInteger(m_chart, m_name+string(m_sid)+".chk", OBJPROP_COLOR, m_clr);
			if (m_tree.IsCheck(m_sid)) m_tree.CheckIt(m_sid, false);
			if (m_tree.IsSelect(m_sid)) m_tree.SelectIt(m_sid, false);
		}
		//    
		m_sid=id; // 
		ObjectSetInteger(m_chart, m_name+string(m_sid)+".lbl", OBJPROP_COLOR, m_selclr);
		ObjectSetInteger(m_chart, m_name+string(m_sid)+".chk", OBJPROP_COLOR, m_selclr);
		m_tree.CheckIt(m_sid, true);
		m_tree.SelectIt(m_sid, true);
		Draw(); //  
		return(BTN_LABEL);
	}
	else if (StringFind(name, ".chk")>=0 && !m_bProperty) //     
	{
		m_tree.SelectBy(TG_ALL, NULL, false);//      
		m_tree.CheckBy(TG_ALL, NULL, false);
		if (m_sid>=0) if (m_tree.IsCheck(m_sid)) m_tree.CheckIt(m_sid, false); //  
		m_sid=id; //  
		m_tree.CheckIt(m_sid, true); //  
		Draw(); //  
		return(BTN_CHECK);
	}
	else if (StringFind(name, ".scroll")>=0)
	{
		int s=m_scroll.OnClick(name); //  
		if (s!=0) { m_y0=(int)-m_scroll.m_value*m_ndy; Draw(); } // ,   
		return(BTN_SCROLL);
	}
	return(-1);
}
//------------------------------------------------------------------	Draw
void CTreeView::Draw()
{
	if (!IsOpenView()) return; //    ,  

	SetRectLbl(m_chart, m_name+".rect", m_wnd, "", m_clr, m_bgclr, m_x, m_y, m_dx, m_dy, m_corn, m_fontsize, m_font, true);
	int ax=int(m_x+m_dx-1.5*m_bdx); int adx=int(1.2*m_bdx); int i=-1;

	i++; SetButton(m_chart, m_name+".collaps", 0, "-", m_bgclr, m_selclr, ax-i*adx, int(m_y+0.5*m_bdy), m_bdx, m_bdy, 0, 7, "Tahoma", false);
	i++; SetButton(m_chart, m_name+".expand", 0, "+", m_bgclr, m_selclr, ax-i*adx, int(m_y+0.5*m_bdy), m_bdx, m_bdy, 0, 7, "Tahoma", false);
	i++; SetButton(m_chart, m_name+".clear", 0, "/", m_bgclr, m_selclr, ax-i*adx, int(m_y+0.5*m_bdy), m_bdx, m_bdy, 0, 7, "Tahoma", false);
	i++; SetButton(m_chart, m_name+".reset", 0, "*", m_bgclr, m_selclr, ax-i*adx, int(m_y+0.5*m_bdy), m_bdx, m_bdy, 0, 7, "Tahoma", false);
	if (m_bProperty)  //    
	{ i++; SetButton(m_chart, m_name+".open", 0, "...", m_bgclr, clrDarkOliveGreen, ax-i*adx, int(m_y+0.5*m_bdy), m_bdx, m_bdy, 0, 7, "Tahoma", false); }
	else
	{ i++; SetButton(m_chart, m_name+".desc", 0, "i", m_bgclr, clrDarkOliveGreen, ax-i*adx, int(m_y+0.5*m_bdy), m_bdx, m_bdy, 0, 7, "Tahoma", m_bDesc); }
	

	int show=0, up=0, dn=0; 
	DrawTree(m_tree.m_root, 1, show, up, dn); //  
	
	if (up<=0 && dn<=0) m_scroll.DeleteView(); //     
	else
	{
		m_scroll.m_max=up+dn; m_scroll.m_value=up;
		m_scroll.m_x=m_x+m_dx-20; m_scroll.m_dx=16; 
		m_scroll.m_y=m_y+2*m_bdy; m_scroll.m_dy=m_dy-3*m_bdy+8;
		m_scroll.Draw(); //   
	}
}
//------------------------------------------------------------------	DrawTree
void CTreeView::DrawTree(CNode *root, int xpos, int &ypos, int &up, int &dn)
{
	if (xpos==1) { root=m_tree.m_root; ypos=0; } //     ,      
	if (root==NULL) { root=m_tree.m_root; xpos=1; } //     ,      
	if (NIL(root)) return; //  
	string name=m_name+string(root.m_id);

	if (!IsOpenView()) return; //    ,  

	int x=m_x0+m_x+5+(xpos-1)*m_bdx;
	int y=m_y0+m_y+5+ypos*m_ndy;
	int ndx=m_ndx-m_bdx; if (!m_bProperty) ndx=m_ndx;
	
	bool ishide=(y<=m_y || y>=m_y+m_dy-m_ndy);
	if (root.m_break && ishide)
	{
		while (y<m_y) { m_y0+=m_ndy; y=m_y0+m_y+5+ypos*m_ndy; }//  
		while (y>m_y+m_dy-m_ndy) { m_y0-=m_ndy; y=m_y0+m_y+5+ypos*m_ndy; }//  
		up=0; dn=0;
		DrawTree(m_tree.m_root, 1, ypos, up, dn); //    
	}
	
	if (!ishide) //      
	{
		string txt=root.m_text; 
		StringTrimLeft(root.m_desc); //   
		if (m_bDesc && root.m_desc!="") txt+="  |  "+root.m_desc; //   
		//  
		bool bgroup=false;
		if (m_bProperty && !NIL(root.m_prev)) if (root.m_prev.m_id==0) bgroup=true;
		color clr=(root.m_select || bgroup) ? m_selclr : m_clr;
		if (root.m_break) clr=clrRed;

		//    
		SetLabel(m_chart, name+".lbl", m_wnd, txt, clr, x+ndx, y-1, m_corn, m_fontsize, m_font);
			
		//   
		if (!m_bProperty || root.m_desc=="" || root.m_id==0 || !root.m_expand) 
			ObjectDelete(m_chart, name+".prop");
		else 
			SetLabel(m_chart, name+".prop", m_wnd, root.m_desc, clr, int(m_x+150), y, m_corn, m_fontsize, m_font);
		
		//  
		string state;
		if (!m_bProperty && !root.m_break)
		{
			state=root.m_check ? CharToString(110) : CharToString(112);
			SetLabel(m_chart, name+".chk", m_wnd, state, clr, x+ndx-m_bdx, y, m_corn, m_fontsize, "Wingdings");
		}
		else ObjectDelete(m_chart, name+".chk");
		
		//   
		state=root.m_expand ? "-" : "+";
		if (ArraySize(root.m_next)>0) //   ,   
			SetButton(m_chart, name+".btn", m_wnd, state, m_clr, m_bgclr, x, y, m_bdx, m_bdy, m_corn, m_fontsize, m_font, root.m_expand);
		else ObjectDelete(m_chart, name+".btn");
		
		//   (    )
		if (root.m_break)
			SetButton(m_chart, name+".dbg", m_wnd, "*", clr, clr, x+ndx-m_bdx-2, y, m_bdx, m_bdy, m_corn, m_fontsize, m_font, false);
		else ObjectDelete(m_chart, name+".dbg");
	}
	else 
	{
		ObjectDelete(m_chart, name+".lbl"); ObjectDelete(m_chart, name+".prop");
		ObjectDelete(m_chart, name+".btn"); ObjectDelete(m_chart, name+".chk"); 
		ObjectDelete(m_chart, name+".dbg"); 
		if (y<m_y) up++; else dn++;
	}
	
	if (!root.m_expand) return; //   ,  
	for (int i=0; i<ArraySize(root.m_next); i++)
	{
		if (NIL(root.m_next[i])) continue;
		ypos++; //  
		DrawTree(root.m_next[i], xpos+1, ypos, up, dn); //   
	}
}
//------------------------------------------------------------------	DeleteView
void CTreeView::DeleteView(CNode *root=NULL, bool delparent=true)
{
	if (root==NULL) root=m_tree.m_root; if (NIL(root)) return;
	if(delparent) // 
	{
		string name=m_name+string(root.m_id);
		ObjectDelete(m_chart, name+".btn");
		ObjectDelete(m_chart, name+".lbl");
		ObjectDelete(m_chart, name+".chk");
		ObjectDelete(m_chart, name+".prop");
	}
	for (int i=0; i<ArraySize(root.m_next); i++)
	{
		if (NIL(root.m_next[i])) continue;
		DeleteView(root.m_next[i], true);
	}
}